/**
 */
package lib;

import java.math.BigDecimal;
import java.math.BigInteger;

import java.util.Date;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Book</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link lib.Book#getTitle <em>Title</em>}</li>
 *   <li>{@link lib.Book#getPages <em>Pages</em>}</li>
 *   <li>{@link lib.Book#getCategory <em>Category</em>}</li>
 *   <li>{@link lib.Book#getAuthors <em>Authors</em>}</li>
 *   <li>{@link lib.Book#getLibrary <em>Library</em>}</li>
 *   <li>{@link lib.Book#getCopies <em>Copies</em>}</li>
 *   <li>{@link lib.Book#getLoans <em>Loans</em>}</li>
 *   <li>{@link lib.Book#getPublishDate <em>Publish Date</em>}</li>
 *   <li>{@link lib.Book#getPrice <em>Price</em>}</li>
 *   <li>{@link lib.Book#getReaders <em>Readers</em>}</li>
 * </ul>
 * </p>
 *
 * @see lib.LibPackage#getBook()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='SufficientCopies'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot SufficientCopies='library.loans->select(book=self)->size() <= copies'"
 * @generated
 */
public interface Book extends EObject
{
    /**
     * Returns the value of the '<em><b>Title</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Title</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Title</em>' attribute.
     * @see #setTitle(String)
     * @see lib.LibPackage#getBook_Title()
     * @model required="true"
     * @generated
     */
    String getTitle();

    /**
     * Sets the value of the '{@link lib.Book#getTitle <em>Title</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Title</em>' attribute.
     * @see #getTitle()
     * @generated
     */
    void setTitle(String value);

    /**
     * Returns the value of the '<em><b>Pages</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Pages</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Pages</em>' attribute.
     * @see #isSetPages()
     * @see #unsetPages()
     * @see #setPages(Integer)
     * @see lib.LibPackage#getBook_Pages()
     * @model unsettable="true" required="true"
     * @generated
     */
    Integer getPages();

    /**
     * Sets the value of the '{@link lib.Book#getPages <em>Pages</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Pages</em>' attribute.
     * @see #isSetPages()
     * @see #unsetPages()
     * @see #getPages()
     * @generated
     */
    void setPages(Integer value);

    /**
     * Unsets the value of the '{@link lib.Book#getPages <em>Pages</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetPages()
     * @see #getPages()
     * @see #setPages(Integer)
     * @generated
     */
    void unsetPages();

    /**
     * Returns whether the value of the '{@link lib.Book#getPages <em>Pages</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Pages</em>' attribute is set.
     * @see #unsetPages()
     * @see #getPages()
     * @see #setPages(Integer)
     * @generated
     */
    boolean isSetPages();

    /**
     * Returns the value of the '<em><b>Category</b></em>' attribute.
     * The default value is <code>"Mystery"</code>.
     * The literals are from the enumeration {@link lib.BookCategory}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Category</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Category</em>' attribute.
     * @see lib.BookCategory
     * @see #isSetCategory()
     * @see #unsetCategory()
     * @see #setCategory(BookCategory)
     * @see lib.LibPackage#getBook_Category()
     * @model default="Mystery" unsettable="true" required="true"
     * @generated
     */
    BookCategory getCategory();

    /**
     * Sets the value of the '{@link lib.Book#getCategory <em>Category</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Category</em>' attribute.
     * @see lib.BookCategory
     * @see #isSetCategory()
     * @see #unsetCategory()
     * @see #getCategory()
     * @generated
     */
    void setCategory(BookCategory value);

    /**
     * Unsets the value of the '{@link lib.Book#getCategory <em>Category</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSetCategory()
     * @see #getCategory()
     * @see #setCategory(BookCategory)
     * @generated
     */
    void unsetCategory();

    /**
     * Returns whether the value of the '{@link lib.Book#getCategory <em>Category</em>}' attribute is set.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return whether the value of the '<em>Category</em>' attribute is set.
     * @see #unsetCategory()
     * @see #getCategory()
     * @see #setCategory(BookCategory)
     * @generated
     */
    boolean isSetCategory();

    /**
     * Returns the value of the '<em><b>Authors</b></em>' reference list.
     * The list contents are of type {@link lib.Writer}.
     * It is bidirectional and its opposite is '{@link lib.Writer#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Authors</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Authors</em>' reference list.
     * @see lib.LibPackage#getBook_Authors()
     * @see lib.Writer#getBooks
     * @model opposite="books" required="true"
     * @generated
     */
    EList<Writer> getAuthors();

    /**
     * Returns the value of the '<em><b>Library</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link lib.Library#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Library</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Library</em>' container reference.
     * @see #setLibrary(Library)
     * @see lib.LibPackage#getBook_Library()
     * @see lib.Library#getBooks
     * @model opposite="books" transient="false"
     * @generated
     */
    Library getLibrary();

    /**
     * Sets the value of the '{@link lib.Book#getLibrary <em>Library</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Library</em>' container reference.
     * @see #getLibrary()
     * @generated
     */
    void setLibrary(Library value);

    /**
     * Returns the value of the '<em><b>Copies</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Copies</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Copies</em>' attribute.
     * @see #setCopies(BigInteger)
     * @see lib.LibPackage#getBook_Copies()
     * @model
     * @generated
     */
    BigInteger getCopies();

    /**
     * Sets the value of the '{@link lib.Book#getCopies <em>Copies</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Copies</em>' attribute.
     * @see #getCopies()
     * @generated
     */
    void setCopies(BigInteger value);

    /**
     * Returns the value of the '<em><b>Loans</b></em>' reference list.
     * The list contents are of type {@link lib.Loan}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Loans</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Loans</em>' reference list.
     * @see lib.LibPackage#getBook_Loans()
     * @model volatile="true" derived="true" ordered="false"
     *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='library.loans->select(book=self)'"
     * @generated
     */
    EList<Loan> getLoans();

    /**
     * Returns the value of the '<em><b>Publish Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Publish Date</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Publish Date</em>' attribute.
     * @see #setPublishDate(Date)
     * @see lib.LibPackage#getBook_PublishDate()
     * @model
     * @generated
     */
    Date getPublishDate();

    /**
     * Sets the value of the '{@link lib.Book#getPublishDate <em>Publish Date</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Publish Date</em>' attribute.
     * @see #getPublishDate()
     * @generated
     */
    void setPublishDate(Date value);

    /**
     * Returns the value of the '<em><b>Price</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Price</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Price</em>' attribute.
     * @see #setPrice(BigDecimal)
     * @see lib.LibPackage#getBook_Price()
     * @model
     * @generated
     */
    BigDecimal getPrice();

    /**
     * Sets the value of the '{@link lib.Book#getPrice <em>Price</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Price</em>' attribute.
     * @see #getPrice()
     * @generated
     */
    void setPrice(BigDecimal value);

    /**
     * Returns the value of the '<em><b>Readers</b></em>' reference list.
     * The list contents are of type {@link lib.Person}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Readers</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Readers</em>' reference list.
     * @see lib.LibPackage#getBook_Readers()
     * @model
     * @generated
     */
    EList<Person> getReaders();

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @model kind="operation"
     *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='loans->size() < copies'"
     * @generated
     */
    boolean isAvailable();

} // Book
