/**
 */
package lib;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see lib.LibFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface LibPackage extends EPackage
{
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "lib";

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "http://lib";

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "lib";

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    LibPackage eINSTANCE = lib.impl.LibPackageImpl.init();

    /**
     * The meta object id for the '{@link lib.impl.BookImpl <em>Book</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.BookImpl
     * @see lib.impl.LibPackageImpl#getBook()
     * @generated
     */
    int BOOK = 0;

    /**
     * The feature id for the '<em><b>Title</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__TITLE = 0;

    /**
     * The feature id for the '<em><b>Pages</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__PAGES = 1;

    /**
     * The feature id for the '<em><b>Category</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__CATEGORY = 2;

    /**
     * The feature id for the '<em><b>Authors</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__AUTHORS = 3;

    /**
     * The feature id for the '<em><b>Library</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__LIBRARY = 4;

    /**
     * The feature id for the '<em><b>Copies</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__COPIES = 5;

    /**
     * The feature id for the '<em><b>Loans</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__LOANS = 6;

    /**
     * The feature id for the '<em><b>Publish Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__PUBLISH_DATE = 7;

    /**
     * The feature id for the '<em><b>Price</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__PRICE = 8;

    /**
     * The feature id for the '<em><b>Readers</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__READERS = 9;

    /**
     * The number of structural features of the '<em>Book</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK_FEATURE_COUNT = 10;

    /**
     * The operation id for the '<em>Is Available</em>' operation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK___IS_AVAILABLE = 0;

    /**
     * The number of operations of the '<em>Book</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK_OPERATION_COUNT = 1;

    /**
     * The meta object id for the '{@link lib.impl.AddressableImpl <em>Addressable</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.AddressableImpl
     * @see lib.impl.LibPackageImpl#getAddressable()
     * @generated
     */
    int ADDRESSABLE = 5;

    /**
     * The feature id for the '<em><b>Address</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESSABLE__ADDRESS = 0;

    /**
     * The number of structural features of the '<em>Addressable</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESSABLE_FEATURE_COUNT = 1;

    /**
     * The number of operations of the '<em>Addressable</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESSABLE_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link lib.impl.LibraryImpl <em>Library</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.LibraryImpl
     * @see lib.impl.LibPackageImpl#getLibrary()
     * @generated
     */
    int LIBRARY = 1;

    /**
     * The feature id for the '<em><b>Address</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__ADDRESS = ADDRESSABLE__ADDRESS;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__NAME = ADDRESSABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Writers</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__WRITERS = ADDRESSABLE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Books</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__BOOKS = ADDRESSABLE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Loans</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__LOANS = ADDRESSABLE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Members</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__MEMBERS = ADDRESSABLE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Employees</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__EMPLOYEES = ADDRESSABLE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Director</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY__DIRECTOR = ADDRESSABLE_FEATURE_COUNT + 6;

    /**
     * The number of structural features of the '<em>Library</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY_FEATURE_COUNT = ADDRESSABLE_FEATURE_COUNT + 7;

    /**
     * The number of operations of the '<em>Library</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LIBRARY_OPERATION_COUNT = ADDRESSABLE_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link lib.impl.PersonImpl <em>Person</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.PersonImpl
     * @see lib.impl.LibPackageImpl#getPerson()
     * @generated
     */
    int PERSON = 3;

    /**
     * The feature id for the '<em><b>Address</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PERSON__ADDRESS = ADDRESSABLE__ADDRESS;

    /**
     * The feature id for the '<em><b>First Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PERSON__FIRST_NAME = ADDRESSABLE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Last Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PERSON__LAST_NAME = ADDRESSABLE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Person</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PERSON_FEATURE_COUNT = ADDRESSABLE_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Person</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PERSON_OPERATION_COUNT = ADDRESSABLE_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link lib.impl.WriterImpl <em>Writer</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.WriterImpl
     * @see lib.impl.LibPackageImpl#getWriter()
     * @generated
     */
    int WRITER = 2;

    /**
     * The feature id for the '<em><b>Address</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER__ADDRESS = PERSON__ADDRESS;

    /**
     * The feature id for the '<em><b>First Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER__FIRST_NAME = PERSON__FIRST_NAME;

    /**
     * The feature id for the '<em><b>Last Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER__LAST_NAME = PERSON__LAST_NAME;

    /**
     * The feature id for the '<em><b>Books</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER__BOOKS = PERSON_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Library</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER__LIBRARY = PERSON_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Writer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER_FEATURE_COUNT = PERSON_FEATURE_COUNT + 2;

    /**
     * The number of operations of the '<em>Writer</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int WRITER_OPERATION_COUNT = PERSON_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link lib.impl.AddressImpl <em>Address</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.AddressImpl
     * @see lib.impl.LibPackageImpl#getAddress()
     * @generated
     */
    int ADDRESS = 4;

    /**
     * The feature id for the '<em><b>Street Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__STREET_NAME = 0;

    /**
     * The feature id for the '<em><b>City</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__CITY = 1;

    /**
     * The feature id for the '<em><b>Zipcode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__ZIPCODE = 2;

    /**
     * The feature id for the '<em><b>Country</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__COUNTRY = 3;

    /**
     * The feature id for the '<em><b>Adressable</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__ADRESSABLE = 4;

    /**
     * The feature id for the '<em><b>Longitude</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__LONGITUDE = 5;

    /**
     * The feature id for the '<em><b>Latitude</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__LATITUDE = 6;

    /**
     * The feature id for the '<em><b>Street Number</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS__STREET_NUMBER = 7;

    /**
     * The number of structural features of the '<em>Address</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS_FEATURE_COUNT = 8;

    /**
     * The number of operations of the '<em>Address</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ADDRESS_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link lib.impl.MemberImpl <em>Member</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.MemberImpl
     * @see lib.impl.LibPackageImpl#getMember()
     * @generated
     */
    int MEMBER = 6;

    /**
     * The feature id for the '<em><b>Address</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER__ADDRESS = PERSON__ADDRESS;

    /**
     * The feature id for the '<em><b>First Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER__FIRST_NAME = PERSON__FIRST_NAME;

    /**
     * The feature id for the '<em><b>Last Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER__LAST_NAME = PERSON__LAST_NAME;

    /**
     * The feature id for the '<em><b>Library</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER__LIBRARY = PERSON_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Loans</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER__LOANS = PERSON_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Books</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER__BOOKS = PERSON_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Member</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER_FEATURE_COUNT = PERSON_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Member</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MEMBER_OPERATION_COUNT = PERSON_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link lib.impl.LoanImpl <em>Loan</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.impl.LoanImpl
     * @see lib.impl.LibPackageImpl#getLoan()
     * @generated
     */
    int LOAN = 7;

    /**
     * The feature id for the '<em><b>Start Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAN__START_DATE = 0;

    /**
     * The feature id for the '<em><b>Member</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAN__MEMBER = 1;

    /**
     * The feature id for the '<em><b>Book</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAN__BOOK = 2;

    /**
     * The feature id for the '<em><b>End Date</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAN__END_DATE = 3;

    /**
     * The number of structural features of the '<em>Loan</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAN_FEATURE_COUNT = 4;

    /**
     * The number of operations of the '<em>Loan</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int LOAN_OPERATION_COUNT = 0;

    /**
     * The meta object id for the '{@link lib.BookCategory <em>Book Category</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see lib.BookCategory
     * @see lib.impl.LibPackageImpl#getBookCategory()
     * @generated
     */
    int BOOK_CATEGORY = 8;


    /**
     * Returns the meta object for class '{@link lib.Book <em>Book</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Book</em>'.
     * @see lib.Book
     * @generated
     */
    EClass getBook();

    /**
     * Returns the meta object for the attribute '{@link lib.Book#getTitle <em>Title</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Title</em>'.
     * @see lib.Book#getTitle()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Title();

    /**
     * Returns the meta object for the attribute '{@link lib.Book#getPages <em>Pages</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Pages</em>'.
     * @see lib.Book#getPages()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Pages();

    /**
     * Returns the meta object for the attribute '{@link lib.Book#getCategory <em>Category</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Category</em>'.
     * @see lib.Book#getCategory()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Category();

    /**
     * Returns the meta object for the reference list '{@link lib.Book#getAuthors <em>Authors</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Authors</em>'.
     * @see lib.Book#getAuthors()
     * @see #getBook()
     * @generated
     */
    EReference getBook_Authors();

    /**
     * Returns the meta object for the container reference '{@link lib.Book#getLibrary <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Library</em>'.
     * @see lib.Book#getLibrary()
     * @see #getBook()
     * @generated
     */
    EReference getBook_Library();

    /**
     * Returns the meta object for the attribute '{@link lib.Book#getCopies <em>Copies</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Copies</em>'.
     * @see lib.Book#getCopies()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Copies();

    /**
     * Returns the meta object for the reference list '{@link lib.Book#getLoans <em>Loans</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Loans</em>'.
     * @see lib.Book#getLoans()
     * @see #getBook()
     * @generated
     */
    EReference getBook_Loans();

    /**
     * Returns the meta object for the attribute '{@link lib.Book#getPublishDate <em>Publish Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Publish Date</em>'.
     * @see lib.Book#getPublishDate()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_PublishDate();

    /**
     * Returns the meta object for the attribute '{@link lib.Book#getPrice <em>Price</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Price</em>'.
     * @see lib.Book#getPrice()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Price();

    /**
     * Returns the meta object for the reference list '{@link lib.Book#getReaders <em>Readers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Readers</em>'.
     * @see lib.Book#getReaders()
     * @see #getBook()
     * @generated
     */
    EReference getBook_Readers();

    /**
     * Returns the meta object for the '{@link lib.Book#isAvailable() <em>Is Available</em>}' operation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the '<em>Is Available</em>' operation.
     * @see lib.Book#isAvailable()
     * @generated
     */
    EOperation getBook__IsAvailable();

    /**
     * Returns the meta object for class '{@link lib.Library <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Library</em>'.
     * @see lib.Library
     * @generated
     */
    EClass getLibrary();

    /**
     * Returns the meta object for the attribute '{@link lib.Library#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see lib.Library#getName()
     * @see #getLibrary()
     * @generated
     */
    EAttribute getLibrary_Name();

    /**
     * Returns the meta object for the containment reference list '{@link lib.Library#getWriters <em>Writers</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Writers</em>'.
     * @see lib.Library#getWriters()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Writers();

    /**
     * Returns the meta object for the containment reference list '{@link lib.Library#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Books</em>'.
     * @see lib.Library#getBooks()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Books();

    /**
     * Returns the meta object for the containment reference list '{@link lib.Library#getLoans <em>Loans</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Loans</em>'.
     * @see lib.Library#getLoans()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Loans();

    /**
     * Returns the meta object for the containment reference list '{@link lib.Library#getMembers <em>Members</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Members</em>'.
     * @see lib.Library#getMembers()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Members();

    /**
     * Returns the meta object for the containment reference list '{@link lib.Library#getEmployees <em>Employees</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Employees</em>'.
     * @see lib.Library#getEmployees()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Employees();

    /**
     * Returns the meta object for the containment reference '{@link lib.Library#getDirector <em>Director</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference '<em>Director</em>'.
     * @see lib.Library#getDirector()
     * @see #getLibrary()
     * @generated
     */
    EReference getLibrary_Director();

    /**
     * Returns the meta object for class '{@link lib.Writer <em>Writer</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Writer</em>'.
     * @see lib.Writer
     * @generated
     */
    EClass getWriter();

    /**
     * Returns the meta object for the reference list '{@link lib.Writer#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Books</em>'.
     * @see lib.Writer#getBooks()
     * @see #getWriter()
     * @generated
     */
    EReference getWriter_Books();

    /**
     * Returns the meta object for the container reference '{@link lib.Writer#getLibrary <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Library</em>'.
     * @see lib.Writer#getLibrary()
     * @see #getWriter()
     * @generated
     */
    EReference getWriter_Library();

    /**
     * Returns the meta object for class '{@link lib.Person <em>Person</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Person</em>'.
     * @see lib.Person
     * @generated
     */
    EClass getPerson();

    /**
     * Returns the meta object for the attribute '{@link lib.Person#getFirstName <em>First Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>First Name</em>'.
     * @see lib.Person#getFirstName()
     * @see #getPerson()
     * @generated
     */
    EAttribute getPerson_FirstName();

    /**
     * Returns the meta object for the attribute '{@link lib.Person#getLastName <em>Last Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Last Name</em>'.
     * @see lib.Person#getLastName()
     * @see #getPerson()
     * @generated
     */
    EAttribute getPerson_LastName();

    /**
     * Returns the meta object for class '{@link lib.Address <em>Address</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Address</em>'.
     * @see lib.Address
     * @generated
     */
    EClass getAddress();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getStreetName <em>Street Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Street Name</em>'.
     * @see lib.Address#getStreetName()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_StreetName();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getCity <em>City</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>City</em>'.
     * @see lib.Address#getCity()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_City();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getZipcode <em>Zipcode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Zipcode</em>'.
     * @see lib.Address#getZipcode()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_Zipcode();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getCountry <em>Country</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Country</em>'.
     * @see lib.Address#getCountry()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_Country();

    /**
     * Returns the meta object for the container reference '{@link lib.Address#getAdressable <em>Adressable</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Adressable</em>'.
     * @see lib.Address#getAdressable()
     * @see #getAddress()
     * @generated
     */
    EReference getAddress_Adressable();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getLongitude <em>Longitude</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Longitude</em>'.
     * @see lib.Address#getLongitude()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_Longitude();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getLatitude <em>Latitude</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Latitude</em>'.
     * @see lib.Address#getLatitude()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_Latitude();

    /**
     * Returns the meta object for the attribute '{@link lib.Address#getStreetNumber <em>Street Number</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Street Number</em>'.
     * @see lib.Address#getStreetNumber()
     * @see #getAddress()
     * @generated
     */
    EAttribute getAddress_StreetNumber();

    /**
     * Returns the meta object for class '{@link lib.Addressable <em>Addressable</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Addressable</em>'.
     * @see lib.Addressable
     * @generated
     */
    EClass getAddressable();

    /**
     * Returns the meta object for the containment reference '{@link lib.Addressable#getAddress <em>Address</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference '<em>Address</em>'.
     * @see lib.Addressable#getAddress()
     * @see #getAddressable()
     * @generated
     */
    EReference getAddressable_Address();

    /**
     * Returns the meta object for class '{@link lib.Member <em>Member</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Member</em>'.
     * @see lib.Member
     * @generated
     */
    EClass getMember();

    /**
     * Returns the meta object for the container reference '{@link lib.Member#getLibrary <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Library</em>'.
     * @see lib.Member#getLibrary()
     * @see #getMember()
     * @generated
     */
    EReference getMember_Library();

    /**
     * Returns the meta object for the reference list '{@link lib.Member#getLoans <em>Loans</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Loans</em>'.
     * @see lib.Member#getLoans()
     * @see #getMember()
     * @generated
     */
    EReference getMember_Loans();

    /**
     * Returns the meta object for the reference list '{@link lib.Member#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Books</em>'.
     * @see lib.Member#getBooks()
     * @see #getMember()
     * @generated
     */
    EReference getMember_Books();

    /**
     * Returns the meta object for class '{@link lib.Loan <em>Loan</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Loan</em>'.
     * @see lib.Loan
     * @generated
     */
    EClass getLoan();

    /**
     * Returns the meta object for the attribute '{@link lib.Loan#getStartDate <em>Start Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Start Date</em>'.
     * @see lib.Loan#getStartDate()
     * @see #getLoan()
     * @generated
     */
    EAttribute getLoan_StartDate();

    /**
     * Returns the meta object for the reference '{@link lib.Loan#getMember <em>Member</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Member</em>'.
     * @see lib.Loan#getMember()
     * @see #getLoan()
     * @generated
     */
    EReference getLoan_Member();

    /**
     * Returns the meta object for the reference '{@link lib.Loan#getBook <em>Book</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Book</em>'.
     * @see lib.Loan#getBook()
     * @see #getLoan()
     * @generated
     */
    EReference getLoan_Book();

    /**
     * Returns the meta object for the attribute '{@link lib.Loan#getEndDate <em>End Date</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>End Date</em>'.
     * @see lib.Loan#getEndDate()
     * @see #getLoan()
     * @generated
     */
    EAttribute getLoan_EndDate();

    /**
     * Returns the meta object for enum '{@link lib.BookCategory <em>Book Category</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Book Category</em>'.
     * @see lib.BookCategory
     * @generated
     */
    EEnum getBookCategory();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    LibFactory getLibFactory();

    /**
     * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each operation of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
     * @generated
     */
    interface Literals
    {
        /**
         * The meta object literal for the '{@link lib.impl.BookImpl <em>Book</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.BookImpl
         * @see lib.impl.LibPackageImpl#getBook()
         * @generated
         */
        EClass BOOK = eINSTANCE.getBook();

        /**
         * The meta object literal for the '<em><b>Title</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__TITLE = eINSTANCE.getBook_Title();

        /**
         * The meta object literal for the '<em><b>Pages</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__PAGES = eINSTANCE.getBook_Pages();

        /**
         * The meta object literal for the '<em><b>Category</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__CATEGORY = eINSTANCE.getBook_Category();

        /**
         * The meta object literal for the '<em><b>Authors</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference BOOK__AUTHORS = eINSTANCE.getBook_Authors();

        /**
         * The meta object literal for the '<em><b>Library</b></em>' container reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference BOOK__LIBRARY = eINSTANCE.getBook_Library();

        /**
         * The meta object literal for the '<em><b>Copies</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__COPIES = eINSTANCE.getBook_Copies();

        /**
         * The meta object literal for the '<em><b>Loans</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference BOOK__LOANS = eINSTANCE.getBook_Loans();

        /**
         * The meta object literal for the '<em><b>Publish Date</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__PUBLISH_DATE = eINSTANCE.getBook_PublishDate();

        /**
         * The meta object literal for the '<em><b>Price</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__PRICE = eINSTANCE.getBook_Price();

        /**
         * The meta object literal for the '<em><b>Readers</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference BOOK__READERS = eINSTANCE.getBook_Readers();

        /**
         * The meta object literal for the '<em><b>Is Available</b></em>' operation.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EOperation BOOK___IS_AVAILABLE = eINSTANCE.getBook__IsAvailable();

        /**
         * The meta object literal for the '{@link lib.impl.LibraryImpl <em>Library</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.LibraryImpl
         * @see lib.impl.LibPackageImpl#getLibrary()
         * @generated
         */
        EClass LIBRARY = eINSTANCE.getLibrary();

        /**
         * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute LIBRARY__NAME = eINSTANCE.getLibrary_Name();

        /**
         * The meta object literal for the '<em><b>Writers</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__WRITERS = eINSTANCE.getLibrary_Writers();

        /**
         * The meta object literal for the '<em><b>Books</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__BOOKS = eINSTANCE.getLibrary_Books();

        /**
         * The meta object literal for the '<em><b>Loans</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__LOANS = eINSTANCE.getLibrary_Loans();

        /**
         * The meta object literal for the '<em><b>Members</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__MEMBERS = eINSTANCE.getLibrary_Members();

        /**
         * The meta object literal for the '<em><b>Employees</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__EMPLOYEES = eINSTANCE.getLibrary_Employees();

        /**
         * The meta object literal for the '<em><b>Director</b></em>' containment reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LIBRARY__DIRECTOR = eINSTANCE.getLibrary_Director();

        /**
         * The meta object literal for the '{@link lib.impl.WriterImpl <em>Writer</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.WriterImpl
         * @see lib.impl.LibPackageImpl#getWriter()
         * @generated
         */
        EClass WRITER = eINSTANCE.getWriter();

        /**
         * The meta object literal for the '<em><b>Books</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference WRITER__BOOKS = eINSTANCE.getWriter_Books();

        /**
         * The meta object literal for the '<em><b>Library</b></em>' container reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference WRITER__LIBRARY = eINSTANCE.getWriter_Library();

        /**
         * The meta object literal for the '{@link lib.impl.PersonImpl <em>Person</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.PersonImpl
         * @see lib.impl.LibPackageImpl#getPerson()
         * @generated
         */
        EClass PERSON = eINSTANCE.getPerson();

        /**
         * The meta object literal for the '<em><b>First Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute PERSON__FIRST_NAME = eINSTANCE.getPerson_FirstName();

        /**
         * The meta object literal for the '<em><b>Last Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute PERSON__LAST_NAME = eINSTANCE.getPerson_LastName();

        /**
         * The meta object literal for the '{@link lib.impl.AddressImpl <em>Address</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.AddressImpl
         * @see lib.impl.LibPackageImpl#getAddress()
         * @generated
         */
        EClass ADDRESS = eINSTANCE.getAddress();

        /**
         * The meta object literal for the '<em><b>Street Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__STREET_NAME = eINSTANCE.getAddress_StreetName();

        /**
         * The meta object literal for the '<em><b>City</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__CITY = eINSTANCE.getAddress_City();

        /**
         * The meta object literal for the '<em><b>Zipcode</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__ZIPCODE = eINSTANCE.getAddress_Zipcode();

        /**
         * The meta object literal for the '<em><b>Country</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__COUNTRY = eINSTANCE.getAddress_Country();

        /**
         * The meta object literal for the '<em><b>Adressable</b></em>' container reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ADDRESS__ADRESSABLE = eINSTANCE.getAddress_Adressable();

        /**
         * The meta object literal for the '<em><b>Longitude</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__LONGITUDE = eINSTANCE.getAddress_Longitude();

        /**
         * The meta object literal for the '<em><b>Latitude</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__LATITUDE = eINSTANCE.getAddress_Latitude();

        /**
         * The meta object literal for the '<em><b>Street Number</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ADDRESS__STREET_NUMBER = eINSTANCE.getAddress_StreetNumber();

        /**
         * The meta object literal for the '{@link lib.impl.AddressableImpl <em>Addressable</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.AddressableImpl
         * @see lib.impl.LibPackageImpl#getAddressable()
         * @generated
         */
        EClass ADDRESSABLE = eINSTANCE.getAddressable();

        /**
         * The meta object literal for the '<em><b>Address</b></em>' containment reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ADDRESSABLE__ADDRESS = eINSTANCE.getAddressable_Address();

        /**
         * The meta object literal for the '{@link lib.impl.MemberImpl <em>Member</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.MemberImpl
         * @see lib.impl.LibPackageImpl#getMember()
         * @generated
         */
        EClass MEMBER = eINSTANCE.getMember();

        /**
         * The meta object literal for the '<em><b>Library</b></em>' container reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference MEMBER__LIBRARY = eINSTANCE.getMember_Library();

        /**
         * The meta object literal for the '<em><b>Loans</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference MEMBER__LOANS = eINSTANCE.getMember_Loans();

        /**
         * The meta object literal for the '<em><b>Books</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference MEMBER__BOOKS = eINSTANCE.getMember_Books();

        /**
         * The meta object literal for the '{@link lib.impl.LoanImpl <em>Loan</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.impl.LoanImpl
         * @see lib.impl.LibPackageImpl#getLoan()
         * @generated
         */
        EClass LOAN = eINSTANCE.getLoan();

        /**
         * The meta object literal for the '<em><b>Start Date</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute LOAN__START_DATE = eINSTANCE.getLoan_StartDate();

        /**
         * The meta object literal for the '<em><b>Member</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LOAN__MEMBER = eINSTANCE.getLoan_Member();

        /**
         * The meta object literal for the '<em><b>Book</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference LOAN__BOOK = eINSTANCE.getLoan_Book();

        /**
         * The meta object literal for the '<em><b>End Date</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute LOAN__END_DATE = eINSTANCE.getLoan_EndDate();

        /**
         * The meta object literal for the '{@link lib.BookCategory <em>Book Category</em>}' enum.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see lib.BookCategory
         * @see lib.impl.LibPackageImpl#getBookCategory()
         * @generated
         */
        EEnum BOOK_CATEGORY = eINSTANCE.getBookCategory();

    }

} //LibPackage
