/**
 */
package lib;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Library</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link lib.Library#getName <em>Name</em>}</li>
 *   <li>{@link lib.Library#getWriters <em>Writers</em>}</li>
 *   <li>{@link lib.Library#getBooks <em>Books</em>}</li>
 *   <li>{@link lib.Library#getLoans <em>Loans</em>}</li>
 *   <li>{@link lib.Library#getMembers <em>Members</em>}</li>
 *   <li>{@link lib.Library#getEmployees <em>Employees</em>}</li>
 *   <li>{@link lib.Library#getDirector <em>Director</em>}</li>
 * </ul>
 * </p>
 *
 * @see lib.LibPackage#getLibrary()
 * @model
 * @generated
 */
public interface Library extends Addressable
{
    /**
     * Returns the value of the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Name</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Name</em>' attribute.
     * @see #setName(String)
     * @see lib.LibPackage#getLibrary_Name()
     * @model required="true"
     * @generated
     */
    String getName();

    /**
     * Sets the value of the '{@link lib.Library#getName <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Name</em>' attribute.
     * @see #getName()
     * @generated
     */
    void setName(String value);

    /**
     * Returns the value of the '<em><b>Writers</b></em>' containment reference list.
     * The list contents are of type {@link lib.Writer}.
     * It is bidirectional and its opposite is '{@link lib.Writer#getLibrary <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Writers</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Writers</em>' containment reference list.
     * @see lib.LibPackage#getLibrary_Writers()
     * @see lib.Writer#getLibrary
     * @model opposite="library" containment="true" ordered="false"
     * @generated
     */
    EList<Writer> getWriters();

    /**
     * Returns the value of the '<em><b>Books</b></em>' containment reference list.
     * The list contents are of type {@link lib.Book}.
     * It is bidirectional and its opposite is '{@link lib.Book#getLibrary <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Books</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Books</em>' containment reference list.
     * @see lib.LibPackage#getLibrary_Books()
     * @see lib.Book#getLibrary
     * @model opposite="library" containment="true"
     * @generated
     */
    EList<Book> getBooks();

    /**
     * Returns the value of the '<em><b>Loans</b></em>' containment reference list.
     * The list contents are of type {@link lib.Loan}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Loans</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Loans</em>' containment reference list.
     * @see lib.LibPackage#getLibrary_Loans()
     * @model containment="true" ordered="false"
     * @generated
     */
    EList<Loan> getLoans();

    /**
     * Returns the value of the '<em><b>Members</b></em>' containment reference list.
     * The list contents are of type {@link lib.Member}.
     * It is bidirectional and its opposite is '{@link lib.Member#getLibrary <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Members</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Members</em>' containment reference list.
     * @see lib.LibPackage#getLibrary_Members()
     * @see lib.Member#getLibrary
     * @model opposite="library" containment="true" ordered="false"
     * @generated
     */
    EList<Member> getMembers();

    /**
     * Returns the value of the '<em><b>Employees</b></em>' containment reference list.
     * The list contents are of type {@link lib.Person}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Employees</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Employees</em>' containment reference list.
     * @see lib.LibPackage#getLibrary_Employees()
     * @model containment="true"
     * @generated
     */
    EList<Person> getEmployees();

    /**
     * Returns the value of the '<em><b>Director</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Director</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Director</em>' containment reference.
     * @see #setDirector(Person)
     * @see lib.LibPackage#getLibrary_Director()
     * @model containment="true"
     * @generated
     */
    Person getDirector();

    /**
     * Sets the value of the '{@link lib.Library#getDirector <em>Director</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Director</em>' containment reference.
     * @see #getDirector()
     * @generated
     */
    void setDirector(Person value);

} // Library
