/**
 */
package lib;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Member</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link lib.Member#getLibrary <em>Library</em>}</li>
 *   <li>{@link lib.Member#getLoans <em>Loans</em>}</li>
 *   <li>{@link lib.Member#getBooks <em>Books</em>}</li>
 * </ul>
 * </p>
 *
 * @see lib.LibPackage#getMember()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AtMostTwoLoans UniqueLoans'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot AtMostTwoLoans='loans->size() <= 2' UniqueLoans='loans->isUnique(book)'"
 * @generated
 */
public interface Member extends Person
{
    /**
     * Returns the value of the '<em><b>Library</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link lib.Library#getMembers <em>Members</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Library</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Library</em>' container reference.
     * @see #setLibrary(Library)
     * @see lib.LibPackage#getMember_Library()
     * @see lib.Library#getMembers
     * @model opposite="members" transient="false"
     * @generated
     */
    Library getLibrary();

    /**
     * Sets the value of the '{@link lib.Member#getLibrary <em>Library</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Library</em>' container reference.
     * @see #getLibrary()
     * @generated
     */
    void setLibrary(Library value);

    /**
     * Returns the value of the '<em><b>Loans</b></em>' reference list.
     * The list contents are of type {@link lib.Loan}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Loans</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Loans</em>' reference list.
     * @see lib.LibPackage#getMember_Loans()
     * @model volatile="true" derived="true" ordered="false"
     *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='library.loans->select(member=self)'"
     * @generated
     */
    EList<Loan> getLoans();

    /**
     * Returns the value of the '<em><b>Books</b></em>' reference list.
     * The list contents are of type {@link lib.Book}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Books</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Books</em>' reference list.
     * @see lib.LibPackage#getMember_Books()
     * @model volatile="true" derived="true" ordered="false"
     *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot derivation='loans->collect(book)'"
     * @generated
     */
    EList<Book> getBooks();

} // Member
