/**
 */
package lib.util;

import lib.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see lib.LibPackage
 * @generated
 */
public class LibAdapterFactory extends AdapterFactoryImpl
{
    /**
     * The cached model package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static LibPackage modelPackage;

    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public LibAdapterFactory()
    {
        if (modelPackage == null)
        {
            modelPackage = LibPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object)
    {
        if (object == modelPackage)
        {
            return true;
        }
        if (object instanceof EObject)
        {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch that delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LibSwitch<Adapter> modelSwitch =
        new LibSwitch<Adapter>()
        {
            @Override
            public Adapter caseBook(Book object)
            {
                return createBookAdapter();
            }
            @Override
            public Adapter caseLibrary(Library object)
            {
                return createLibraryAdapter();
            }
            @Override
            public Adapter caseWriter(Writer object)
            {
                return createWriterAdapter();
            }
            @Override
            public Adapter casePerson(Person object)
            {
                return createPersonAdapter();
            }
            @Override
            public Adapter caseAddress(Address object)
            {
                return createAddressAdapter();
            }
            @Override
            public Adapter caseAddressable(Addressable object)
            {
                return createAddressableAdapter();
            }
            @Override
            public Adapter caseMember(Member object)
            {
                return createMemberAdapter();
            }
            @Override
            public Adapter caseLoan(Loan object)
            {
                return createLoanAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object)
            {
                return createEObjectAdapter();
            }
        };

    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target)
    {
        return modelSwitch.doSwitch((EObject)target);
    }


    /**
     * Creates a new adapter for an object of class '{@link lib.Book <em>Book</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Book
     * @generated
     */
    public Adapter createBookAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Library <em>Library</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Library
     * @generated
     */
    public Adapter createLibraryAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Writer <em>Writer</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Writer
     * @generated
     */
    public Adapter createWriterAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Person <em>Person</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Person
     * @generated
     */
    public Adapter createPersonAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Address <em>Address</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Address
     * @generated
     */
    public Adapter createAddressAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Addressable <em>Addressable</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Addressable
     * @generated
     */
    public Adapter createAddressableAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Member <em>Member</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Member
     * @generated
     */
    public Adapter createMemberAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link lib.Loan <em>Loan</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see lib.Loan
     * @generated
     */
    public Adapter createLoanAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter()
    {
        return null;
    }

} //LibAdapterFactory
